# MQTTController Change Log

Online docs: https://reactor.toggledbits.com/docs/MQTTController/

**Versions >=21355 require Reactor build 21354 or higher.**

## 22260

* Add `owntracks_in_region` template.

## 22150

* Add `tasmota_sensor_flora` template contribution by @Crille

## 22091 

* Add hostname to client ID given to the broker -- some brokers (e.g. mosquitto) don't like multiple clients using the same ID, so if we rely only on the controller ID, the user could accidentally create a collision (controller ID is determined by the user config). Adding the hostname should avoid that in most cases. Where it doesn't/can't, the `clientId` can be set in `config.options` for the broker conneection.

## 22086

* Improve excessive-retry detection with mqtt package.

## 22081

* Improve echo config handling for rule states and global variables.
* Trap errors on regular expressions in config and report to log (i.e. don't crash if user enters a bad regexp).

## 22029

* Echo function now publishes rule states and global variable values. Please see the docs linked at top for more details.

## 22024

* Fix command case for Tasmota generic relay (some firmware complains if its not all uppercase)

## 22009

* Allow `entity_identifier` to be set to `id/name` (which is a synonym for `combined`), or `name/id`, the order of the levels being as indicated.

## 22008

* Users may now add the entity name to echo telemetry topics via the `entity_identifier` configuration key (`echo` section); please refer to the documentation for details.

## 21361

* PR 0000280: Fix error thrown on perform when 'entities' key missing from config entirely.

## 21355

* System alerts are now published via `reactor/<controller-id>/alerts`

## 21343

* Add `include_groups` and `exclude_groups` filters for echo selection.
* Default `exclude_capabilities` when *not defined* will filter out extension capabilities.
* Docs updates and fixes.

## 21331

* Detect stalled connections on reconnect (openLuup) and hard-close/recycle. Note that openLuup is not supported as a "production" broker because it does not fully implement the MQTT 3.1.1 standard/requirements.
* More carefully guard sensors (in templates) from payloads that don't contain the sensor data (i.e. avoid setting null value if an update is published with data missing).
* Additional templates for Tasmota and Shelly.
* Documentation updates and clarifications.

## 21321

* Fix incorrect scope reference in *tasmota_generic_relay* payload.
* Additional helpful debug.

## 21320

* The `init` section for device initializations (optional) has been added; refer to the docs.
* The `x_mqtt_device.poll` action is now defined for devices with `query` configured; refer to the docs.
* Allow `username` and `password` in controller config for authentication.

## 21319

* Initial release version; reports at 21313
